//DESCRIPTION:Aus Tabellen werden VCARD-QR-Codes erzeugt und eingefärbt. Die Farbe kann dynamisch geändert werden
//copyright: SteigArt | Daniel Steiger
//Version: 4.3
/**
- QR-Code auf der Seite erstellen die die Tabelle enthält
*/

if(app.documents.length == 0){
    alert("Zuerst ein Dokument öffnen, vor dem Start des Scripts");
}else{
    var qrdataTab = qrdataTabelle();

    alert("QR-Codes sind erstellt");
}

function qrdataTabelle(){
    var dok = app.activeDocument;
    var qrDataExists = false // Variable zur Feststellung, ob das Textfraem gefunden wurde

    // Alle Textramen finden
    for(var i = 0; i<dok.textFrames.length; i++){
        var foundTextFrame = dok.textFrames[i];

        // Nur Textframes mit dem Namen qrdata
        if(foundTextFrame.name === "qrdata"){
            qrDataExists = true;
            var qrdataID = foundTextFrame.id;

            //Seitenzahl in der die Tabelle ist
            dataTablePage = foundTextFrame.parent.pages[0].name;

            // qrdata-Tabelle auslesen
            qrCodeContent(qrdataID, dataTablePage); //Funktion zum auslesen der qrdatas
        }
    }

    // Prüfen ob das Texframe qrdata vorhanden ist
    if(!qrDataExists){
        alert("Keine Tabelle mit den VCARD-Vorgaben vorhanden. Bitte vorhandenes Snippet einfügen");
    }
}

// Hauptfunktion zum erstellen des QR-Codes ---------------------------------------------------------------------------------
function qrCodeContent(textFrameID, dataTablePage){
    var dok = app.activeDocument;
    var qrDataTabID = textFrameID;
    var qrPosition = [5,5,30,30]; // Standardposition bei neuem Code
    var qrPage = app.activeWindow.activePage.documentOffset;


    // Die Tabelle im Textframe "qrdata" auswählen
    var tab = dok.textFrames.itemByID(qrDataTabID).tables[0];
    // alert("Inhalt der ersten Tabellenzelle: " + tab.cells[0].contents);
    tab.cells[0].contents = "ID" + qrDataTabID;

    // Variable Objekte
    var alloStyles = dok.objectStyles;
    var oStyleName = "QR-code";
    var oStylesYes = "";
    var qrBegin = "BEGIN:VCARD\nVERSION:3.0";
    var qrEnd = "END:VCARD";
    var qrcontent = "";
    
    // Durchsuchen der Zelle nach dem gesuchten Inhalt
    for (var i = 0; i < tab.cells.length; i++){
        var cell = tab.cells[i];
        if(cell.isValid){
            var num = i+1
            if(cell.contents == "Name") qrName = tab.cells[num].contents;
            if(cell.contents == "Vorname") qrVorname = tab.cells[num].contents;
            if(cell.contents == "Firma") qrFirma = tab.cells[num].contents;
            if(cell.contents == "Titel") qrTitel = tab.cells[num].contents; // Achtung Verwirrung: Titel wird in VCARD als Berufsbezeichnung verwendet. Der eigentliche Titel steht unter N: 
            if(cell.contents == "Berufsbez.") qrBezeichn = tab.cells[num].contents;
            if(cell.contents == "Abteilung") qrAbteil = tab.cells[num].contents;
            if(cell.contents == "Ort G") qrOrtG = tab.cells[num].contents;
            if(cell.contents == "Adresse G") qrAdrG = tab.cells[num].contents;
            if(cell.contents == "PLZ G") qrPLZG = tab.cells[num].contents;
            if(cell.contents == "Land G") qrLandG = tab.cells[num].contents;
            if(cell.contents == "Adresse P") qrAdrP = tab.cells[num].contents;
            if(cell.contents == "PLZ P") qrPLZP = tab.cells[num].contents;
            if(cell.contents == "Ort P") qrOrtP = tab.cells[num].contents;
            if(cell.contents == "Land P") qrLandP = tab.cells[num].contents;
            if(cell.contents == "Mail G") qrEmailWork = tab.cells[num].contents;
            if(cell.contents == "Mail P") qrEmailPriv = tab.cells[num].contents;
            if(cell.contents == "Zentrale") qrTelMain = tab.cells[num].contents;
            if(cell.contents == "Direkt") qrTelDirekt = tab.cells[num].contents;
            if(cell.contents == "Mobile") qrTelMobile = tab.cells[num].contents;
            if(cell.contents == "Fax") qrTelFax = tab.cells[num].contents;
            if(cell.contents == "Homepage") qrURL = tab.cells[num].contents;
            if(cell.contents == "Privat") qrTelPrivat = tab.cells[num].contents;
            if(cell.contents == "Farbe") qrColor = tab.cells[num].fillColor.name;
        } 
        else{
            alert("Keine Tabellenzellen vorhanden.");
        }
        
    }
        // QR-Code zusammensetzen
        var codecontent = qrBegin;
        // codecontent += "\nN:" + qrName + ";" + qrVorname;
        
        codecontent += "\nN:" + qrName + ";" + qrVorname + ";;" + qrTitel;
        codecontent += "\nFN:"+qrTitel + qrVorname + " " + qrName;
        codecontent += "\nTITLE:" + qrBezeichn; // Achtung Verwirrung: Titel wird in VCARD als Berufsbezeichnung verwendet. Der eigentliche Titel steht unter N:
        codecontent += "\nORG:" + qrFirma + ";" + qrAbteil;
        if(qrOrtG != ""){
            codecontent += "\nADR;TYPE=work:" + ";;" + qrAdrG + ";" + qrOrtG + ";;" + qrPLZG + ";" + qrLandG;
        }
        if(qrOrtP != ""){
            codecontent += "\nADR;TYPE=home:" + ";;" + qrAdrP + ";" + qrOrtP + ";;" + qrPLZP + ";" + qrLandP;
        }
        codecontent += "\nTEL;TYPE=main:" + qrTelMain;
        codecontent += "\nTEL;TYPE=work:" + qrTelDirekt;
        codecontent += "\nTEL;TYPE=cell:" + qrTelMobile;
        codecontent += "\nTEL;TYPE=home:" + qrTelPrivat;
        codecontent += "\nTEL;TYPE=fax:" + qrTelFax;
        codecontent += "\nEMAIL;TYPE=work:" + qrEmailWork;
        codecontent += "\nEMAIL;TYPE=home:" + qrEmailPriv;
        codecontent += "\nURL:" + qrURL;
        codecontent += "\n" + qrEnd;
          
        // Funktion aufrufen für die Prüfung der QR-Codeboxen
        var qrCodeData = qrCodeExist(textFrameID);

        //Falls ein QR-Code gefunden wurde, zeigen wir die Informationen an
        if(qrCodeData.qrCodeFound){
            /*alert(
                "QR-Code Position: " + qrCodeData.qrFramePosition + "\n" +
                "Seite: " + qrCodeData.qrFramePage + "\n" +
                "Objektformat" + (qrCodeData.qrObjectStyleName || "Kein Objektformat")
            );*/
            qrPosition = qrCodeData.qrFramePosition;
            var qrCodeObjectFormatName = qrCodeData.qrObjectStyleName;
            qrPage = parseInt(qrCodeData.qrFramePage-1);
        }else{
        //    qrPage = app.activeWindow.activePage.documentOffset;
           qrPage = dataTablePage-1;
        }

        // Bildbox oberhalb erstellen
        var qrSel = dok.pages[qrPage].rectangles.add();

        // QR-Codebox erstellen mit ausgewäahltem Inhalt befüllen
        qrSel.createPlainTextQRCode (codecontent);

        // QR-Code Position
        qrSel.geometricBounds = qrPosition;
        // qrSel.appliedObjectStyle = dok.objectStyles.itemByName[qrCodeData.qrObjectStyleName];
        qrSel.name = "VCARD-CodeID" + textFrameID;
        qrSel.fit(FitOptions.PROPORTIONALLY); // Inhalt proportional zum Rahmen anpassen
        qrSel.fit(FitOptions.CENTER_CONTENT); // Inhalt im Rahmen zentrieren

        
        // QR-Code mittels Effekt einfärben
        qrSel.transparencySettings.innerGlowSettings.applied = true; // Effekt aktivieren
        qrSel.transparencySettings.innerGlowSettings.blendMode = BlendMode.NORMAL; //Füllmodus
        qrSel.transparencySettings.innerGlowSettings.effectColor = qrColor; // Farbe wählen
        qrSel.transparencySettings.innerGlowSettings.noise = 0; // Rauschen auf 0 gesetzt
        qrSel.transparencySettings.innerGlowSettings.opacity = 100; // Deckkraft auf 100%
        qrSel.transparencySettings.innerGlowSettings.size = 50; //Grösse auf 50, ein grösserer Wert erzeugt einen JS-Fehler
        qrSel.transparencySettings.innerGlowSettings.spread = 100; // Abschwächung auf 100%
        qrSel.transparencySettings.innerGlowSettings.technique = GlowTechnique.PRECISE; // Technik auf Präzise
        
        //Prüfen ob Objektformat vorhanden ist
        if(qrCodeObjectFormatName != null){
            qrSel.appliedObjectStyle = dok.objectStyles.itemByName(qrCodeObjectFormatName);
        }
    }

// Funktion, um zu prüfen, ob bereits QR-Codes existieren und die relevanten Daten zurückzugeben --------------------------------------------
function qrCodeExist(textFrameID) {
    var dok = app.activeDocument;
    var qrCodeName = "VCARD-CodeID" + textFrameID;
    var qrCodeData = {
        qrCodeFound: false,
        qrFramePosition: null,
        qrFramePage: null,
        qrObjectStyleName: null
    };

    // Durchlaufe alle Rechtecke im Dokument
    for (var r = 0; r < dok.rectangles.length; r++) {
        var qrFrame = dok.rectangles[r];

        // Prüfen, ob der Name des Rechtecks "VCARD-QRcode" ist
        if (qrFrame.name == qrCodeName) {
            qrCodeData.qrCodeFound = true;

            // Position des Rechtecks auslesen
            qrCodeData.qrFramePosition = qrFrame.geometricBounds;

            // Seite des Rechtecks auslesen und sicherstellen, dass es auf einer Seite ist
            if (qrFrame.parentPage != null) {
                qrCodeData.qrFramePage = qrFrame.parentPage.name;
            }

            // Prüfen, ob dem Rechteck ein Objektformat zugewiesen ist
            var qrobjectStyle = qrFrame.appliedObjectStyle;
            if (qrobjectStyle != null && qrobjectStyle.name != "[Ohne]") {
                qrCodeData.qrObjectStyleName = qrobjectStyle.name;
            }

            // Vorhandene QR-Codebox löschen
            qrFrame.remove();

            // Nur der erste "VCARD-QRcode" benötigt daher Schleife beenden
            break;
        }
    }

    return qrCodeData;
}